(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common/http'), require('rxjs'), require('rxjs/operators'), require('@angular/core'), require('@angular/platform-browser'), require('@angular/common'), require('@angular/material')) :
    typeof define === 'function' && define.amd ? define('versions-netcore-angular', ['exports', '@angular/common/http', 'rxjs', 'rxjs/operators', '@angular/core', '@angular/platform-browser', '@angular/common', '@angular/material'], factory) :
    (factory((global['versions-netcore-angular'] = {}),global.ng.common.http,global.rxjs,global.rxjs.operators,global.ng.core,global.ng.platformBrowser,global.ng.common,global.ng.material));
}(this, (function (exports,i1,rxjs,operators,i0,platformBrowser,common,material) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m)
            return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length)
                    o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FVSAng = /** @class */ (function () {
        function FVSAng() {
        }
        Object.defineProperty(FVSAng.prototype, "internalName", {
            get: /**
             * @return {?}
             */ function () {
                return this.name;
            },
            enumerable: true,
            configurable: true
        });
        return FVSAng;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var VersionsNetcoreAngularService = /** @class */ (function () {
        function VersionsNetcoreAngularService(http) {
            this.http = http;
        }
        /**
         * @return {?}
         */
        VersionsNetcoreAngularService.prototype.FVS = /**
         * @return {?}
         */
            function () {
                console.log('get fvs');
                return this.http.get('api/Utils/GetVersions');
            };
        /**
         * @return {?}
         */
        VersionsNetcoreAngularService.prototype.FVSAngular = /**
         * @return {?}
         */
            function () {
                console.log('get fvs angular');
                return this.http.get('npm-shrinkwrap.json').pipe(operators.switchMap(function (data) {
                    var e_1, _a;
                    /** @type {?} */
                    var ret = ( /** @type {?} */(data));
                    /** @type {?} */
                    var d = ret.dependencies;
                    /** @type {?} */
                    var arr = new Array();
                    /** @type {?} */
                    var f = new FVSAng();
                    f.name = ret.name;
                    f.fileVersion = ret.version;
                    arr.push(f);
                    try {
                        for (var _b = __values(Array.from(Object.keys(d))), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var key = _c.value;
                            /** @type {?} */
                            var dep = ( /** @type {?} */(d[key]));
                            if (dep.dev) {
                                continue;
                            }
                            f = new FVSAng();
                            f.fileVersion = dep.version;
                            f.name = key;
                            arr.push(f);
                        }
                    }
                    catch (e_1_1) {
                        e_1 = { error: e_1_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_1)
                                throw e_1.error;
                        }
                    }
                    return rxjs.of(arr);
                    // window.alert(JSON.stringify(data));
                    // const arr = new Array<FVSAngular>();
                    // const f = new FVSAngular();
                    // f.dev = false;
                    // f.name = data['name'];
                    // f.version = data['version'];
                    // arr.push(f);
                    // const deps = data['dependencies'] ;
                    // // for (let index = 0; index < deps.keys.length; index++) {
                    // //     const element = deps[deps.keys[index]];
                    // //     const newF = new FVSAngular();
                    // //     newF.version = element['version'];
                    // //     newF.name =  deps.keys[index];
                    // //     arr.push(newF);
                    // // }
                    // return of(arr);
                }));
            };
        VersionsNetcoreAngularService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        VersionsNetcoreAngularService.ctorParameters = function () {
            return [
                { type: i1.HttpClient }
            ];
        };
        /** @nocollapse */ VersionsNetcoreAngularService.ngInjectableDef = i0.defineInjectable({ factory: function VersionsNetcoreAngularService_Factory() { return new VersionsNetcoreAngularService(i0.inject(i1.HttpClient)); }, token: VersionsNetcoreAngularService, providedIn: "root" });
        return VersionsNetcoreAngularService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DisplayNetCoreComponent = /** @class */ (function () {
        function DisplayNetCoreComponent(dialogRef, data) {
            this.dialogRef = dialogRef;
            this.data = data;
        }
        /**
         * @return {?}
         */
        DisplayNetCoreComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        /**
         * @return {?}
         */
        DisplayNetCoreComponent.prototype.onNoClick = /**
         * @return {?}
         */
            function () {
                this.dialogRef.close();
            };
        DisplayNetCoreComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'vers-display-net-core',
                        template: "<p>\r\n  {{data.internalName }}\r\n</p>\r\n\r\n<div *ngFor=\"let item of data | keyvalue\">\r\n    Key: <b>{{item.key}}</b>  Value: <b>{{item.value}}</b>\r\n</div>\r\n<div mat-dialog-actions>\r\n    <button mat-button (click)=\"onNoClick()\">Close</button>\r\n   </div>",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        DisplayNetCoreComponent.ctorParameters = function () {
            return [
                { type: material.MatDialogRef },
                { type: undefined, decorators: [{ type: i0.Inject, args: [material.MAT_DIALOG_DATA,] }] }
            ];
        };
        return DisplayNetCoreComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var VersionsNetcoreAngularComponent = /** @class */ (function () {
        function VersionsNetcoreAngularComponent(vs, dialog) {
            this.vs = vs;
            this.dialog = dialog;
            this.displayedColumnsNET = ['internalName', 'companyName', 'fileVersion', 'AllInfo'];
            this.displayedColumnsNPM = ['name', 'version', 'AllInfo'];
        }
        /**
         * @return {?}
         */
        VersionsNetcoreAngularComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                console.log('ng on init versions');
                this.vs.FVSAngular().subscribe(function (it) {
                    _this.dataSourceNPM = new material.MatTableDataSource(it);
                    _this.dataSourceNPM.sort = _this.sortAng;
                });
                this.vs.FVS().subscribe(function (it) {
                    console.log(it.length);
                    _this.dataSourceNET = new material.MatTableDataSource(it);
                    _this.dataSourceNET.sort = _this.sortNet;
                });
            };
        /**
         * @param {?} filterValue
         * @return {?}
         */
        VersionsNetcoreAngularComponent.prototype.applyFilterNET = /**
         * @param {?} filterValue
         * @return {?}
         */
            function (filterValue) {
                this.dataSourceNET.filter = filterValue.trim().toLowerCase();
            };
        /**
         * @param {?} filterValue
         * @return {?}
         */
        VersionsNetcoreAngularComponent.prototype.applyFilterNPM = /**
         * @param {?} filterValue
         * @return {?}
         */
            function (filterValue) {
                this.dataSourceNPM.filter = filterValue.trim().toLowerCase();
            };
        /**
         * @param {?} el
         * @return {?}
         */
        VersionsNetcoreAngularComponent.prototype.infoElementNPM = /**
         * @param {?} el
         * @return {?}
         */
            function (el) {
                /** @type {?} */
                var dialogRef = this.dialog.open(DisplayNetCoreComponent, {
                    // width: '250px',
                    data: el
                });
            };
        /**
         * @param {?} el
         * @return {?}
         */
        VersionsNetcoreAngularComponent.prototype.infoElementNET = /**
         * @param {?} el
         * @return {?}
         */
            function (el) {
                /** @type {?} */
                var dialogRef = this.dialog.open(DisplayNetCoreComponent, {
                    // width: '250px',
                    data: el
                });
                // let ret = 'info';
                // for (const key in el) {
                //   if (!el.hasOwnProperty(key)) {
                //     continue;
                //   }
                //   const val = el[key];
                //   if (('' + val ).trim().length > 0) {
                //     ret += `${key}=${val};`;
                //   }
                // }
                // return ret;
            };
        VersionsNetcoreAngularComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'vers-versions-netcore-angular',
                        template: " <a href=\"about#npmvers\">View Npm components ({{dataSourceNPM?.data.length}} )</a>\r\n&nbsp;\r\n <a href=\"about#netvers\">View  NET components ( {{dataSourceNET?.data.length}} )</a>\r\n\r\n<p>\r\n    <a id=\"netvers\" name=\"netvers\">.NET components: {{dataSourceNET?.data.length}}</a>    \r\n  </p>\r\n\r\n  <mat-form-field>\r\n    <input matInput (keyup)=\"applyFilterNET($event.target.value)\" placeholder=\"Filter\">\r\n  </mat-form-field> \r\n<table mat-table [dataSource]=\"dataSourceNET\" matSort class=\"mat-elevation-z8\">\r\n    <ng-container matColumnDef=\"internalName\" sticky>\r\n        <th mat-header-cell *matHeaderCellDef mat-sort-header> Name </th>\r\n        <td mat-cell *matCellDef=\"let element;let i=index\" matTooltip={{element.fileName}}> \r\n            {{i+1}})   {{element.internalName}} </td>\r\n      </ng-container>\r\n      <ng-container matColumnDef=\"companyName\">\r\n        <th mat-header-cell *matHeaderCellDef mat-sort-header> companyName </th>\r\n        <td mat-cell *matCellDef=\"let element\"> {{element.companyName}} </td>\r\n      </ng-container>\r\n      <ng-container matColumnDef=\"fileVersion\">\r\n        <th mat-header-cell *matHeaderCellDef mat-sort-header> fileVersion </th>\r\n        <td mat-cell *matCellDef=\"let element\"> {{element.fileVersion}} </td>\r\n      </ng-container>\r\n      <ng-container matColumnDef=\"AllInfo\">\r\n        <th mat-header-cell *matHeaderCellDef >  </th>\r\n        <td mat-cell *matCellDef=\"let element\">\r\n            <button mat-raised-button (click)=\"infoElementNET(element)\">Show Info</button>\r\n        </td>\r\n      </ng-container>\r\n      \r\n      <tr mat-header-row *matHeaderRowDef=\"displayedColumnsNET;sticky: true\"></tr>\r\n      <tr mat-row *matRowDef=\"let row; columns: displayedColumnsNET;\"></tr>\r\n</table>\r\n\r\n<a id=\"npmvers\" name=\"npmvers\">NPM Components: {{dataSourceNPM?.data.length}}</a>\r\n<mat-form-field>\r\n  <input matInput (keyup)=\"applyFilterNPM($event.target.value)\" placeholder=\"Filter\">\r\n</mat-form-field> \r\n<table mat-table [dataSource]=\"dataSourceNPM\" matSort class=\"mat-elevation-z8\">\r\n  <ng-container matColumnDef=\"name\" sticky>\r\n      <th mat-header-cell *matHeaderCellDef mat-sort-header> Name </th>\r\n      <td mat-cell *matCellDef=\"let element;let i=index\" matTooltip={{element.name}}> \r\n      {{i+1}}) {{element.name}} </td>\r\n    </ng-container>\r\n    <ng-container matColumnDef=\"version\">\r\n      <th mat-header-cell *matHeaderCellDef mat-sort-header> fileVersion </th>\r\n      <td mat-cell *matCellDef=\"let element\"> {{element.fileVersion}} </td>\r\n    </ng-container>\r\n    <ng-container matColumnDef=\"AllInfo\">\r\n      <th mat-header-cell *matHeaderCellDef >  </th>\r\n      <td mat-cell *matCellDef=\"let element\">\r\n          <button mat-raised-button (click)=\"infoElementNPM(element)\">Show Info</button>\r\n      </td>\r\n    </ng-container>\r\n    \r\n    <tr mat-header-row *matHeaderRowDef=\"displayedColumnsNPM;sticky: true\"></tr>\r\n    <tr mat-row *matRowDef=\"let row; columns: displayedColumnsNPM;\"></tr>\r\n</table>\r\n\r\n\r\n"
                    }] }
        ];
        /** @nocollapse */
        VersionsNetcoreAngularComponent.ctorParameters = function () {
            return [
                { type: VersionsNetcoreAngularService },
                { type: material.MatDialog }
            ];
        };
        VersionsNetcoreAngularComponent.propDecorators = {
            sortNet: [{ type: i0.ViewChild, args: [material.MatSort,] }],
            sortAng: [{ type: i0.ViewChild, args: [material.MatSort,] }]
        };
        return VersionsNetcoreAngularComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var VersionsNetcoreAngularModule = /** @class */ (function () {
        function VersionsNetcoreAngularModule() {
        }
        VersionsNetcoreAngularModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [VersionsNetcoreAngularComponent, DisplayNetCoreComponent],
                        imports: [
                            common.CommonModule,
                            platformBrowser.BrowserModule,
                            material.MatAutocompleteModule,
                            material.MatBadgeModule,
                            material.MatBottomSheetModule,
                            material.MatButtonModule,
                            material.MatButtonToggleModule,
                            material.MatCardModule,
                            material.MatCheckboxModule,
                            material.MatChipsModule,
                            material.MatDatepickerModule,
                            material.MatDialogModule,
                            material.MatDividerModule,
                            material.MatExpansionModule,
                            material.MatGridListModule,
                            material.MatIconModule,
                            material.MatInputModule,
                            material.MatListModule,
                            material.MatMenuModule,
                            material.MatNativeDateModule,
                            material.MatPaginatorModule,
                            material.MatProgressBarModule,
                            material.MatProgressSpinnerModule,
                            material.MatRadioModule,
                            material.MatRippleModule,
                            material.MatSelectModule,
                            material.MatSidenavModule,
                            material.MatSliderModule,
                            material.MatSlideToggleModule,
                            material.MatSnackBarModule,
                            material.MatSortModule,
                            material.MatStepperModule,
                            material.MatTableModule,
                            material.MatTabsModule,
                            material.MatToolbarModule,
                            material.MatTooltipModule,
                            material.MatTreeModule,
                        ],
                        entryComponents: [DisplayNetCoreComponent],
                        exports: [VersionsNetcoreAngularComponent, DisplayNetCoreComponent]
                    },] }
        ];
        return VersionsNetcoreAngularModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.VersionsNetcoreAngularService = VersionsNetcoreAngularService;
    exports.VersionsNetcoreAngularComponent = VersionsNetcoreAngularComponent;
    exports.VersionsNetcoreAngularModule = VersionsNetcoreAngularModule;
    exports.DisplayNetCoreComponent = DisplayNetCoreComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=versions-netcore-angular.umd.js.map