import { OnInit } from '@angular/core';
import { MatTableDataSource, MatSort, MatDialog } from '@angular/material';
import { VersionsNetcoreAngularService } from './versions-netcore-angular.service';
import { FileVersionInfo, FVSAng } from './FileVersion';
export declare class VersionsNetcoreAngularComponent implements OnInit {
    private vs;
    dialog: MatDialog;
    constructor(vs: VersionsNetcoreAngularService, dialog: MatDialog);
    fvs: FileVersionInfo[];
    dataSourceNET: MatTableDataSource<FileVersionInfo>;
    dataSourceNPM: MatTableDataSource<FVSAng>;
    displayedColumnsNET: string[];
    sortNet: MatSort;
    displayedColumnsNPM: string[];
    sortAng: MatSort;
    ngOnInit(): void;
    applyFilterNET(filterValue: string): void;
    applyFilterNPM(filterValue: string): void;
    infoElementNPM(el: FileVersionInfo): void;
    infoElementNET(el: FileVersionInfo): void;
}
