import { __values } from 'tslib';
import { HttpClient } from '@angular/common/http';
import { of } from 'rxjs';
import { switchMap } from 'rxjs/operators';
import { Injectable, Component, ViewChild, NgModule, Inject, defineInjectable, inject } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { CommonModule } from '@angular/common';
import { MatDialogRef, MAT_DIALOG_DATA, MatTableDataSource, MatSort, MatDialog, MatAutocompleteModule, MatBadgeModule, MatBottomSheetModule, MatButtonModule, MatButtonToggleModule, MatCardModule, MatCheckboxModule, MatChipsModule, MatDatepickerModule, MatDialogModule, MatDividerModule, MatExpansionModule, MatGridListModule, MatIconModule, MatInputModule, MatListModule, MatMenuModule, MatNativeDateModule, MatPaginatorModule, MatProgressBarModule, MatProgressSpinnerModule, MatRadioModule, MatRippleModule, MatSelectModule, MatSidenavModule, MatSliderModule, MatSlideToggleModule, MatSnackBarModule, MatSortModule, MatStepperModule, MatTableModule, MatTabsModule, MatToolbarModule, MatTooltipModule, MatTreeModule } from '@angular/material';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FVSAng = /** @class */ (function () {
    function FVSAng() {
    }
    Object.defineProperty(FVSAng.prototype, "internalName", {
        get: /**
         * @return {?}
         */
        function () {
            return this.name;
        },
        enumerable: true,
        configurable: true
    });
    return FVSAng;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var VersionsNetcoreAngularService = /** @class */ (function () {
    function VersionsNetcoreAngularService(http) {
        this.http = http;
    }
    /**
     * @return {?}
     */
    VersionsNetcoreAngularService.prototype.FVS = /**
     * @return {?}
     */
    function () {
        console.log('get fvs');
        return this.http.get('api/Utils/GetVersions');
    };
    /**
     * @return {?}
     */
    VersionsNetcoreAngularService.prototype.FVSAngular = /**
     * @return {?}
     */
    function () {
        console.log('get fvs angular');
        return this.http.get('npm-shrinkwrap.json').pipe(switchMap(function (data) {
            var e_1, _a;
            /** @type {?} */
            var ret = (/** @type {?} */ (data));
            /** @type {?} */
            var d = ret.dependencies;
            /** @type {?} */
            var arr = new Array();
            /** @type {?} */
            var f = new FVSAng();
            f.name = ret.name;
            f.fileVersion = ret.version;
            arr.push(f);
            try {
                for (var _b = __values(Array.from(Object.keys(d))), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var key = _c.value;
                    /** @type {?} */
                    var dep = (/** @type {?} */ (d[key]));
                    if (dep.dev) {
                        continue;
                    }
                    f = new FVSAng();
                    f.fileVersion = dep.version;
                    f.name = key;
                    arr.push(f);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return of(arr);
            // window.alert(JSON.stringify(data));
            // const arr = new Array<FVSAngular>();
            // const f = new FVSAngular();
            // f.dev = false;
            // f.name = data['name'];
            // f.version = data['version'];
            // arr.push(f);
            // const deps = data['dependencies'] ;
            // // for (let index = 0; index < deps.keys.length; index++) {
            // //     const element = deps[deps.keys[index]];
            // //     const newF = new FVSAngular();
            // //     newF.version = element['version'];
            // //     newF.name =  deps.keys[index];
            // //     arr.push(newF);
            // // }
            // return of(arr);
        }));
    };
    VersionsNetcoreAngularService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    VersionsNetcoreAngularService.ctorParameters = function () { return [
        { type: HttpClient }
    ]; };
    /** @nocollapse */ VersionsNetcoreAngularService.ngInjectableDef = defineInjectable({ factory: function VersionsNetcoreAngularService_Factory() { return new VersionsNetcoreAngularService(inject(HttpClient)); }, token: VersionsNetcoreAngularService, providedIn: "root" });
    return VersionsNetcoreAngularService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DisplayNetCoreComponent = /** @class */ (function () {
    function DisplayNetCoreComponent(dialogRef, data) {
        this.dialogRef = dialogRef;
        this.data = data;
    }
    /**
     * @return {?}
     */
    DisplayNetCoreComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @return {?}
     */
    DisplayNetCoreComponent.prototype.onNoClick = /**
     * @return {?}
     */
    function () {
        this.dialogRef.close();
    };
    DisplayNetCoreComponent.decorators = [
        { type: Component, args: [{
                    selector: 'vers-display-net-core',
                    template: "<p>\r\n  {{data.internalName }}\r\n</p>\r\n\r\n<div *ngFor=\"let item of data | keyvalue\">\r\n    Key: <b>{{item.key}}</b>  Value: <b>{{item.value}}</b>\r\n</div>\r\n<div mat-dialog-actions>\r\n    <button mat-button (click)=\"onNoClick()\">Close</button>\r\n   </div>",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    DisplayNetCoreComponent.ctorParameters = function () { return [
        { type: MatDialogRef },
        { type: undefined, decorators: [{ type: Inject, args: [MAT_DIALOG_DATA,] }] }
    ]; };
    return DisplayNetCoreComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var VersionsNetcoreAngularComponent = /** @class */ (function () {
    function VersionsNetcoreAngularComponent(vs, dialog) {
        this.vs = vs;
        this.dialog = dialog;
        this.displayedColumnsNET = ['internalName', 'companyName', 'fileVersion', 'AllInfo'];
        this.displayedColumnsNPM = ['name', 'version', 'AllInfo'];
    }
    /**
     * @return {?}
     */
    VersionsNetcoreAngularComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        console.log('ng on init versions');
        this.vs.FVSAngular().subscribe(function (it) {
            _this.dataSourceNPM = new MatTableDataSource(it);
            _this.dataSourceNPM.sort = _this.sortAng;
        });
        this.vs.FVS().subscribe(function (it) {
            console.log(it.length);
            _this.dataSourceNET = new MatTableDataSource(it);
            _this.dataSourceNET.sort = _this.sortNet;
        });
    };
    /**
     * @param {?} filterValue
     * @return {?}
     */
    VersionsNetcoreAngularComponent.prototype.applyFilterNET = /**
     * @param {?} filterValue
     * @return {?}
     */
    function (filterValue) {
        this.dataSourceNET.filter = filterValue.trim().toLowerCase();
    };
    /**
     * @param {?} filterValue
     * @return {?}
     */
    VersionsNetcoreAngularComponent.prototype.applyFilterNPM = /**
     * @param {?} filterValue
     * @return {?}
     */
    function (filterValue) {
        this.dataSourceNPM.filter = filterValue.trim().toLowerCase();
    };
    /**
     * @param {?} el
     * @return {?}
     */
    VersionsNetcoreAngularComponent.prototype.infoElementNPM = /**
     * @param {?} el
     * @return {?}
     */
    function (el) {
        /** @type {?} */
        var dialogRef = this.dialog.open(DisplayNetCoreComponent, {
            // width: '250px',
            data: el
        });
    };
    /**
     * @param {?} el
     * @return {?}
     */
    VersionsNetcoreAngularComponent.prototype.infoElementNET = /**
     * @param {?} el
     * @return {?}
     */
    function (el) {
        /** @type {?} */
        var dialogRef = this.dialog.open(DisplayNetCoreComponent, {
            // width: '250px',
            data: el
        });
        // let ret = 'info';
        // for (const key in el) {
        //   if (!el.hasOwnProperty(key)) {
        //     continue;
        //   }
        //   const val = el[key];
        //   if (('' + val ).trim().length > 0) {
        //     ret += `${key}=${val};`;
        //   }
        // }
        // return ret;
    };
    VersionsNetcoreAngularComponent.decorators = [
        { type: Component, args: [{
                    selector: 'vers-versions-netcore-angular',
                    template: " <a href=\"about#npmvers\">View Npm components ({{dataSourceNPM?.data.length}} )</a>\r\n&nbsp;\r\n <a href=\"about#netvers\">View  NET components ( {{dataSourceNET?.data.length}} )</a>\r\n\r\n<p>\r\n    <a id=\"netvers\" name=\"netvers\">.NET components: {{dataSourceNET?.data.length}}</a>    \r\n  </p>\r\n\r\n  <mat-form-field>\r\n    <input matInput (keyup)=\"applyFilterNET($event.target.value)\" placeholder=\"Filter\">\r\n  </mat-form-field> \r\n<table mat-table [dataSource]=\"dataSourceNET\" matSort class=\"mat-elevation-z8\">\r\n    <ng-container matColumnDef=\"internalName\" sticky>\r\n        <th mat-header-cell *matHeaderCellDef mat-sort-header> Name </th>\r\n        <td mat-cell *matCellDef=\"let element;let i=index\" matTooltip={{element.fileName}}> \r\n            {{i+1}})   {{element.internalName}} </td>\r\n      </ng-container>\r\n      <ng-container matColumnDef=\"companyName\">\r\n        <th mat-header-cell *matHeaderCellDef mat-sort-header> companyName </th>\r\n        <td mat-cell *matCellDef=\"let element\"> {{element.companyName}} </td>\r\n      </ng-container>\r\n      <ng-container matColumnDef=\"fileVersion\">\r\n        <th mat-header-cell *matHeaderCellDef mat-sort-header> fileVersion </th>\r\n        <td mat-cell *matCellDef=\"let element\"> {{element.fileVersion}} </td>\r\n      </ng-container>\r\n      <ng-container matColumnDef=\"AllInfo\">\r\n        <th mat-header-cell *matHeaderCellDef >  </th>\r\n        <td mat-cell *matCellDef=\"let element\">\r\n            <button mat-raised-button (click)=\"infoElementNET(element)\">Show Info</button>\r\n        </td>\r\n      </ng-container>\r\n      \r\n      <tr mat-header-row *matHeaderRowDef=\"displayedColumnsNET;sticky: true\"></tr>\r\n      <tr mat-row *matRowDef=\"let row; columns: displayedColumnsNET;\"></tr>\r\n</table>\r\n\r\n<a id=\"npmvers\" name=\"npmvers\">NPM Components: {{dataSourceNPM?.data.length}}</a>\r\n<mat-form-field>\r\n  <input matInput (keyup)=\"applyFilterNPM($event.target.value)\" placeholder=\"Filter\">\r\n</mat-form-field> \r\n<table mat-table [dataSource]=\"dataSourceNPM\" matSort class=\"mat-elevation-z8\">\r\n  <ng-container matColumnDef=\"name\" sticky>\r\n      <th mat-header-cell *matHeaderCellDef mat-sort-header> Name </th>\r\n      <td mat-cell *matCellDef=\"let element;let i=index\" matTooltip={{element.name}}> \r\n      {{i+1}}) {{element.name}} </td>\r\n    </ng-container>\r\n    <ng-container matColumnDef=\"version\">\r\n      <th mat-header-cell *matHeaderCellDef mat-sort-header> fileVersion </th>\r\n      <td mat-cell *matCellDef=\"let element\"> {{element.fileVersion}} </td>\r\n    </ng-container>\r\n    <ng-container matColumnDef=\"AllInfo\">\r\n      <th mat-header-cell *matHeaderCellDef >  </th>\r\n      <td mat-cell *matCellDef=\"let element\">\r\n          <button mat-raised-button (click)=\"infoElementNPM(element)\">Show Info</button>\r\n      </td>\r\n    </ng-container>\r\n    \r\n    <tr mat-header-row *matHeaderRowDef=\"displayedColumnsNPM;sticky: true\"></tr>\r\n    <tr mat-row *matRowDef=\"let row; columns: displayedColumnsNPM;\"></tr>\r\n</table>\r\n\r\n\r\n"
                }] }
    ];
    /** @nocollapse */
    VersionsNetcoreAngularComponent.ctorParameters = function () { return [
        { type: VersionsNetcoreAngularService },
        { type: MatDialog }
    ]; };
    VersionsNetcoreAngularComponent.propDecorators = {
        sortNet: [{ type: ViewChild, args: [MatSort,] }],
        sortAng: [{ type: ViewChild, args: [MatSort,] }]
    };
    return VersionsNetcoreAngularComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var VersionsNetcoreAngularModule = /** @class */ (function () {
    function VersionsNetcoreAngularModule() {
    }
    VersionsNetcoreAngularModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [VersionsNetcoreAngularComponent, DisplayNetCoreComponent],
                    imports: [
                        CommonModule,
                        BrowserModule,
                        MatAutocompleteModule,
                        MatBadgeModule,
                        MatBottomSheetModule,
                        MatButtonModule,
                        MatButtonToggleModule,
                        MatCardModule,
                        MatCheckboxModule,
                        MatChipsModule,
                        MatDatepickerModule,
                        MatDialogModule,
                        MatDividerModule,
                        MatExpansionModule,
                        MatGridListModule,
                        MatIconModule,
                        MatInputModule,
                        MatListModule,
                        MatMenuModule,
                        MatNativeDateModule,
                        MatPaginatorModule,
                        MatProgressBarModule,
                        MatProgressSpinnerModule,
                        MatRadioModule,
                        MatRippleModule,
                        MatSelectModule,
                        MatSidenavModule,
                        MatSliderModule,
                        MatSlideToggleModule,
                        MatSnackBarModule,
                        MatSortModule,
                        MatStepperModule,
                        MatTableModule,
                        MatTabsModule,
                        MatToolbarModule,
                        MatTooltipModule,
                        MatTreeModule,
                    ],
                    entryComponents: [DisplayNetCoreComponent],
                    exports: [VersionsNetcoreAngularComponent, DisplayNetCoreComponent]
                },] }
    ];
    return VersionsNetcoreAngularModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { VersionsNetcoreAngularService, VersionsNetcoreAngularComponent, VersionsNetcoreAngularModule, DisplayNetCoreComponent };

//# sourceMappingURL=versions-netcore-angular.js.map